import java.io.*;

public class Car implements Serializable, Cloneable
{

	String maker;
	Engine engine;
	Trunk trunk;

	public Car()
	{
		maker = "Ford";
		engine = new Engine(4);
		trunk = new Trunk("Medium");
	}

	public Car(String ma,  Engine e, Trunk t)
	{
		maker = ma;
		engine = e;
		trunk = t;
	}

	public String toString()
	{
		return engine.numCyl + " cylinder " + maker + " with " + trunk.size + " trunk";
	}

	// added for performance comparison
	public Object clone() throws CloneNotSupportedException
	{

		Car cClone = (Car)super.clone();
		cClone.engine = (Engine)engine.clone();
		cClone.trunk = (Trunk)trunk.clone();

		return cClone;
	}

}