import java.util.*;

public class PerfDriver
{
	static public void main(String[] args)
	{

		try
		{
			final int iter = 10000;
			Car c1 = new Car("Chevy", new Engine(6), new Trunk("Large"));

			long start1 = System.currentTimeMillis();
			for(int i=0; i<iter; i++)
			{
				ObjectCloner.deepCopy(c1);
			}
			long time1 = System.currentTimeMillis() - start1;

			long start2 = System.currentTimeMillis();
			for(int i=0; i<iter; i++)
			{
				c1.clone();
			}
			long time2 = System.currentTimeMillis() - start2;

			double d1 = time1;
			double d2 = time2;
			double percentDiff = 100 - ((d2/d1)*100);
			System.out.println("For " + iter + " iterations:");
			System.out.println("Serialize deep copy time = " + d1 + " ms");
			System.out.println("Clone deep copy time =     " + d2 + " ms");
			System.out.println("Clone is " + String.valueOf(percentDiff) + "% faster");
		}
		catch(CloneNotSupportedException ex)
		{
			System.out.println("Clone not supported exception = " + ex);
		}
		catch(Exception ee)
		{
			System.out.println("General Exception = " + ee);
		}


	}
}